<?php

require_once(__DIR__ . '/../f1-register-flow.php');
require_once('EmailServiceStub.php');

/**
 * TestRegistrationStep2.php
 * Created By: nico
 * Created On: 8/16/2015
 *
 * @backupGlobals disabled
 */
class RegistrationStep2Test extends PHPUnit_Framework_TestCase
{
    public function testValidateMissingRequiredData()
    {
        $formData = [
            'registration_email' => 'foo@bar.com',
            'registration_first' => 'Foo',
            'registration_last' => 'Bar',
            'registration_password' => 'testpassword8',
            'registration_password_confirm' => 'testpassword8'
        ];
        $fakeEmailService = new EmailServiceStub();
        $reg = new \F1\RegisterFlow\RegistrationStep2($fakeEmailService);
        $result = $reg->processFormData($formData);
        $this->assertTrue(is_wp_error($result), 'processFormData should return an error when missing required data');
        $this->assertEmpty($fakeEmailService->emails);
    }

    public function testProcessStep2Data()
    {
        $formData = [
            'registration_email' => 'foo@bar.com',
            'registration_login' => 'foo@bar.com',
            'registration_first' => 'Foo',
            'registration_last' => 'Bar',
            'registration_mobile' => '3249993333',
            'registration_password' => 'testpassword8',
            'registration_password_confirm' => 'testpassword8'
        ];
        $fakeEmailService = new EmailServiceStub();
        $reg = new \F1\RegisterFlow\RegistrationStep2($fakeEmailService);
        $result = $reg->processFormData($formData);
        $this->assertTrue(is_string($result), 'processFormData should return registration key if no error');
        $this->assertNotEmpty($fakeEmailService->emails);
    }
}